///bs:-input,console
#include<bits\stdc++.h>

using namespace std;

const int MAXN = 2000, INF = 1e9, CNT_DIR = 8;

int c[MAXN][MAXN];

int xm, ym, xa, ya;

int n, m;

int dst(int x1, int y1, int x2, int y2) {
	int dx = x1 - x2, dy = y1 - y2;
	return dx * dx + dy * dy;
}

int getDirection(int x, int y) {
	int dx = xm - x, dy = ym - y;
	if (abs(dx) == abs(dy)) {
		if (dx < 0 && dy > 0) return 1;
		if (dx > 0 && dy > 0) return 3;
		if (dx > 0 && dy < 0) return 5;
		return 7;
	}
	if (abs(dy) > abs(dx)) {
		if (dy > 0) return 2;
		return 6;
	}
	if (dx > 0) return 4;
	return 0;
}

int revDir(int d) {
	return (d + CNT_DIR / 2) % CNT_DIR;
}

bool check() {
	vector<pair<int, int> > rev;
	for (int x = 0; x < n; x++) {
		for (int y = 0; y < m; y++) {
			if (x == xm && y == ym) continue;
			int d = getDirection(x, y);
			if (d != c[x][y]) {
				if (d != revDir(c[x][y])) return 0;
				rev.push_back({x, y});
			}
		}
	}
	for (xa = 0; xa < n; xa++) {
		bool fl = 1;
		ya = -1;
		for (auto [x, y] : rev) {
			if (x == xa) continue;
			// cerr << "y " << y << ' ' <<  ya << ' ' << fl << endl;
			if (ya == -1) ya = y;
			if (ya != y) fl = 0;
		}
		if (fl) {
			if (ya == -1) ya = rev[0].second;
			return 1;
		}
	}
	return 0;
}

int main() {

	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> c[i][j];
			c[i][j]--;
		}
	}
	for (xm = 0; xm < n; xm++) {
		for (ym = 0; ym < m; ym++) {
			if (check()) {
				cout << xm + 1 << ' ' << ym + 1 << endl;
				cout << xa + 1 << ' ' << ya + 1 << endl;
				return 0;
			}
		}
	}
	exit(-1);
	return 0;
}