#include "testlib.h"
#include <iostream>
#include <set>
#include <cmath>

using namespace std;

char s[200010];
int a[200010], b[200010];

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt(1, 200000, "n");
    inf.readEoln();
    for (int i = 0; i < n + 1; i++){
        if (i != n) {
            s[i] = inf.readChar();
        }
        a[i] = ouf.readInt(1, n + 1, "ai");
        b[i] = ans.readInt(1, n + 1, "bi");
    }
    int ja = 0, pa = 0;
    for (int i = 0; i < n; i++){
        if (s[i] == 'A') {
            if (a[i] < a[i + 1]) {
                pa++;
            } else {
                pa--;
            }
            if (b[i] < b[i + 1]) {
                ja++;
            } else {
                ja--;
            }
        }
    }
    sort(a, a + n + 1);
    for (int i = 0; i < n + 1; i++)
        if (a[i] - 1 != i)
            pa = 2 * n;
    if (abs(ja) >= abs(pa))
        quitf(_ok, "ja = %d, pa = %d", ja, pa);
    else
        quitf(_wa, "participant answer = %d worse than jury answer = %d", pa, ja);
}
