#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

struct pnt {
    ll x, y;
    ll lsq() const { return x * x + y * y; }

    pnt operator-(pnt const &rhs) const { return pnt{x - rhs.x, y - rhs.y}; }
    ll operator*(pnt const &rhs) const { return x * rhs.y - y * rhs.x; }
};

istream &operator>>(istream &in, pnt &it) {
    return in >> it.x >> it.y;
}

int main() {

    in(int, n)
    vector<pnt> info(n);
    cin >> info;

    unordered_set<int> unused;
    int start = 0;
    for (int i = 0; i < n; i++) {
        unused.insert(i);
        if (info[i].y < info[start].y || info[i].y == info[start].y && info[i].x < info[start].x) {
            start = i;
        }
    }

    vector<int> ans{start};
    unused.erase(start);
    for (int i = 1; i < n; i++) {
        int cur = ans.back();
        int next = *unused.begin();
        for (int p : unused) {
            auto v_next = info[next] - info[cur];
            auto v_p = info[p] - info[cur];
            ll rot = v_p * v_next;
            if (rot > 0 || rot == 0 && v_p.lsq() < v_next.lsq()) {
                next = p;
            }
        }
        ans.push_back(next);
        unused.erase(next);
    }

    for (int i : ans) {
        cout << i + 1 << ' ';
    }
    cout << '\n';

}