#include "testlib.h"
#include <bits/stdc++.h>
 
#define rand(l, r) l + (unsigned int) rd() % (r - l + 1)
 
using namespace std;
 
const int MAXN = 1500;
 
int xm, ym;
 
mt19937 rd;
 
int getDirection(int x, int y) {
    if (x == xm && y == ym) return rand(0, 7);
    int dx = xm - x, dy = ym - y;
    if (abs(dx) == abs(dy)) {
        if (dx < 0 && dy > 0) return 1;
        if (dx > 0 && dy > 0) return 3;
        if (dx > 0 && dy < 0) return 5;
        return 7;
    }
    if (abs(dy) > abs(dx)) {
        if (dy > 0) return 2;
        return 6;
    }
    if (dx > 0) return 4;
    return 0;
}
 
int a[MAXN][MAXN];
 
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
 
    int seed = atoi(argv[1]);
    rd.seed(seed);
 
    int n = rand(2, MAXN);
    int m;
    if (n == 2) m = rand(3, MAXN);
    else m = rand(2, MAXN);
 
    xm = rand(0, n - 1), ym = rand(0, m - 1);
    cout << n << ' ' << m << '\n';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            a[i][j] = getDirection(i, j);
        }
    }
    int xa = n - 1, ya = m - 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == xa || j == ya) a[i][j] = (a[i][j] + 4) % 8;
            cout << a[i][j] + 1;
            if (j != m - 1) cout << ' ';
        }
        cout << '\n';
    }
}