#include "testlib.h"
#include <bits/stdc++.h>
#define mp make_pair
 
#define rand(l, r) l + (unsigned int) rd() % (r - l + 1)
 
using namespace std;
 
const int MAXN = 20;
 
int xm, ym;
 
mt19937 rd;
 
int getDirection(int x, int y) {
    if (x == xm && y == ym) return rand(0, 7);
    int dx = xm - x, dy = ym - y;
    if (abs(dx) == abs(dy)) {
        if (dx < 0 && dy > 0) return 1;
        if (dx > 0 && dy > 0) return 3;
        if (dx > 0 && dy < 0) return 5;
        return 7;
    }
    if (abs(dy) > abs(dx)) {
        if (dy > 0) return 2;
        return 6;
    }
    if (dx > 0) return 4;
    return 0;
}
 
int a[MAXN][MAXN];
 
int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
 
    int seed = atoi(argv[1]);
    rd.seed(seed);
 
    int n = rand(MAXN / 2, MAXN), m = rand(MAXN / 2, MAXN);

    vector<pair<int, int> > compassPos = {
        {1, 0}, {0, 0}, {0, 1},
        {0, m - 2}, {0, m - 1}, {1, m - 1},
        {n - 2, m - 1}, {n - 1, m - 1}, {n - 1, m - 2},
        {n - 1, 1}, {n - 1, 0}, {n - 2, 0}
    };

    int var = atoi(argv[2]);

    xm = compassPos[var].first, ym = compassPos[var].second;
    cout << n << ' ' << m << '\n';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            a[i][j] = getDirection(i, j);
        }
    }
    int xa = rand(0, n - 1), ya = rand(0, m - 1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == xa || j == ya) a[i][j] = (a[i][j] + 4) % 8;
            cout << a[i][j] + 1;
            if (j != m - 1) cout << ' ';
        }
        cout << '\n';
    }
}