/// Created by Arsenii Kirillov

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <functional>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;/*
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }*/

ll mx = (ll)9e18;

void solve() {
    auto gcd = [&](ll a, ll b) {
        //cerr << a << " " << b << endl;
        while (b) {
            a %= b;
            swap(a, b);
        }
        return a;
    };
    int n, xl, xr, yl, yr, xp, yp;
    cin >> n >> xl >> yl >> xr >> yr >> xp >> yp;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++)
        cin >> x[i] >> y[i];
    ll ans = 9e18 + 10;
    vector<pair<ll, ll>> mas(n);
    for (int i = 0; i < n; i++)
        mas[i].second = 2 * (xr - xl + yr - yl) + 8 * (i + 1);

    auto go = [&](int i, int xx, int yy) {
        //cout << i << " " << xx << " " << yy << endl;
        int ans = 0;
        for (int qwe = 0; qwe < 2; qwe++) {
            if (xx == xl
                 - i - 1) {
                if (x[i] == xl - i - 1 && yy <= y[i])
                    return ans + y[i] - yy;
                else {
                    ans += (yr + i + 1) - yy;
                    yy = yr + i + 1;
                }
            }
            //cout << "!" << ans << endl;
            if (yy == yr + i + 1) {
                if (y[i] == yr + i + 1 && xx <= x[i])
                    return ans + x[i] - xx;
                else {
                    ans += (xr + i + 1) - xx;
                    xx = xr + i + 1;
                }
            }
            //cout << "!" << ans << endl;
            if (xx == xr + i + 1) {
                if (x[i] == xr + i + 1 && yy >= y[i])
                    return ans + yy - y[i];
                else {
                    ans += yy - (yl - i - 1);
                    yy = yl - i - 1;
                }
            }
            //cout << "!" << ans << endl;
            if (yy == yl - i - 1) {
                if (y[i] == yl - i - 1 && xx >= x[i])
                    return ans + xx - x[i];
                else {
                    ans += xx - (xl - i - 1);
                    xx = xl - i - 1;
                }
            }
            //cout << "!" << ans << endl;
        }
        return ans;
    };

    function<pair<ll, ll>(ll, ll)> gcd2 = [&](ll a, ll b) {
        if (b == 0)
            return make_pair((ll)1, (ll)0);
        auto p = gcd2(b, a % b);
        return make_pair(p.second, p.first - (a / b) * p.second);

    };

    auto calc = [&]() {
        ll a = mas[0].first, b = mas[0].second;
        for (int i = 1; i < n; i++) {
            ll c = mas[i].first, d = mas[i].second;
            //cout << a << " " << b << " " << c << " " << d << endl;
            ll q = gcd(b, mas[i].second);
            if (a % q != mas[i].first % q)
                return (ll)9e18 + 10;
            if (a > c) {
                swap(a, c);
                swap(b, d);
            }
            auto p = gcd2(b, d);
            ll bb = b * (d / gcd(b, d));
            a = ((b * p.first * (c - a) / gcd(b, d) + a) % bb + bb) % bb;
            b = bb;
        }
        return a;
    };

    for (int mask = 0; mask < (1 << n); mask++) {
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i))
                mas[i].first = go(i, xl - i - 1, yp);
            else
                mas[i].first = go(i, xr + i + 1, yp);
        }
        ll cur = calc();
        //cout << cur << endl;
        ans = min(ans, cur);
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i))
                mas[i].first = go(i, xp, yl - i - 1);
            else
                mas[i].first = go(i, xp, yr + i + 1);
        }
        cur = calc();
        //cout << cur << endl;
        ans = min(ans, cur);
    }
    if (ans >= (ll)9e18)
        ans = -1;
    cout << (ll)ans << endl;
}


int main() {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
/*
2
3 3 3 3 3 3
2 3
1 1
*/
