using namespace std;

//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <stack>
#include <queue>
#include <tuple>
#include <map>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';cout.flush();
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define X first
#define Y second

struct Node {
    map<char, Node *> next;
    int cnt;
};

Node *build(Node *node, char c, vector<Node *> &level) {
    auto nx = node->next.find(c);
    if (nx == node->next.end()) {
        Node *nd = new Node();
        level.pb(nd);
        node->next[c] = nd;
        ++nd->cnt;
        return nd;
    } else {
        ++(nx->second)->cnt;
        return nx->second;
    }
}

void solver() {
    int n;
    cin >> n;

    vector <string> a(n);
    fori(i, n) {
        cin >> a[i];
    }
    int m = a[0].size();

    vector <vector<Node *>> levels(m, vector<Node *>());
    Node *root = new Node();
    fori(i, n) {
        Node *cur = root;
        fori(j, m) {
            cur = build(cur, a[i][j], levels[j]);
        }
    }

    for (int j = m - 1; j >= 0; --j) {
        bool ok = true;
        for (const auto& nd:  levels[j]) {
            ok = ok && nd->cnt % 2 == 0;
        }
        if (ok) {
            cout << j + 1 << "\n";
            return;
        }
    }
    cout << 0 << "\n";
}

int main() {
//    fastio;
    solver();
}