//
// by Grigoriy Khlytin on 21.10.2022
//

#include "testlib.h"

using namespace std;

typedef long long int ll;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    ll m = inf.readLong(3LL, 100LL, "m");

    inf.readEoln();

    for (int i = 0; i < m; i++) {
        ll x1 = inf.readLong(-10'000LL, 10'000LL, "x1");
        inf.readSpace();
        ll y1 = inf.readLong(-10'000LL, 10'000LL, "y1");
        inf.readSpace();
        ll x2 = inf.readLong(-10'000LL, 10'000LL, "x2");
        inf.readSpace();
        ll y2 = inf.readLong(-10'000LL, 10'000LL, "y2");

        inf.readEoln();

        ensuref(x1 != x2 || y1 != y2,
                "the beginning and end of the segment must not coincide");
    }

    inf.readEof();
}
